package xmlcaviargui;

import javax.swing.JOptionPane;

public class CheckConsistency{


    public static boolean checkFrame(FrameData frame){
	
	int boxNo;

	for(boxNo = 0; boxNo < FrameData.GROUP_BOXES; boxNo++){
	    if(isConsistent(frame.groupBox[boxNo]) == -1){
	    	if(JOptionPane.showConfirmDialog(null,
   	        	  ("Inconsistent combination for Group box " + boxNo +
			   " do you wish to continue anyway?"),
	             	   "Consistency Error",
	           	   JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION)
		
			return false;
	    }
	    
	    boolean[] indBoxes = frame.groupBox[boxNo].getIndBoxes();
	    boolean found = false;
    	    for(int j = 0; j<indBoxes.length; j++){
    		if(indBoxes[j] && frame.singleBox[j].isDefault()){
	    		if(JOptionPane.showConfirmDialog(null,
   	        	  ("Group box " + boxNo + " has member " + j + 
			   " who is not in this frame. Do you wish to continue anyway?"),
	             	   "Consistency Error",
	           	   JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION)
			return false;
		}
	    }
	}

	for(boxNo = 0; boxNo < FrameData.SINGLE_BOXES; boxNo++){
	    if(isConsistent(frame.singleBox[boxNo]) == -1){
	    	if(JOptionPane.showConfirmDialog(null,
   	        	  ("Inconsistent combination for Individual box " + boxNo +
			   " do you wish to continue anyway?"),
	             	   "Consistency Error",
	           	   JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION)
		
		    return false;
	    }
	}

	return true;
    }

    protected final static String[][] consistentIndString = {
	{"none\t", "none\t", "none\t", "none\t"},
	{"immobile", "move\t", "walker\t", "walking\t"},
	{"immobile", "inactive", "walker\t", "active\t"},
	{"immobile", "inactive", "walker\t", "inactive"},
	{"immobile", "inactive", "leaving object", "active\t"},
	{"immobile", "inactive", "leaving object", "inactive"},
	{"walking\t", "move\t", "walker\t", "walking\t"},
	{"walking\t", "move\t", "walker\t", "running\t"},
	{"shop enter", "move\t", "walker\t", "walking\t"},
	{"shop enter", "shop enter", "walker\t", "walking\t"},
	{"window shop", "move\t", "walker\t", "walking\t"},
	{"window shop", "shop enter", "walker\t", "walking\t"},
	{"window shop", "browsing", "browser\t", "active\t"},
	{"window shop", "browsing", "browser\t", "inactive"},
	{"shop exit", "move\t", "walker\t", "walking\t"},
	{"shop exit", "shop exit", "walker\t", "walking\t"},
	{"shop reenter", "move\t", "walker\t", "walking\t"},
	{"shop reenter", "shop enter", "walker\t", "walking\t"},
	{"shop reenter", "shop exit", "walker\t", "walking\t"},
	{"browsing", "move\t", "walker\t", "walking\t"},
	{"browsing", "browsing", "browser\t", "active\t"},
	{"browsing", "browsing", "browser\t", "inactive"},
	{"drop down", "move\t", "walker\t", "walking\t"},
	{"drop down", "browsing", "browser\t", "active\t"},
	{"drop down", "browsing", "browser\t", "inactive"},
	{"drop down", "inactive", "walker\t", "active\t"},
	{"drop down", "inactive", "walker\t", "inactive"},
	{"immobile", "inactive", "left object\t", "inactive"}
    };
    
    protected final static int[][] consistentInd = {
	{SingleBox.NONE_SCE, SingleBox.NONE_SIT, SingleBox.NONE_ROLE, SingleBox.NONE_MOV},
	//Idle
    	{SingleBox.IMMOBILE, SingleBox.MOVING_SIT, SingleBox.WALKER, SingleBox.WALK},
    	{SingleBox.IMMOBILE, SingleBox.INACTIVE_SIT, SingleBox.WALKER, SingleBox.ACTIVE},
    	{SingleBox.IMMOBILE, SingleBox.INACTIVE_SIT, SingleBox.WALKER, SingleBox.INACTIVE},
    	{SingleBox.IMMOBILE, SingleBox.INACTIVE_SIT, SingleBox.LEFT_OBJECT, SingleBox.ACTIVE},
    	{SingleBox.IMMOBILE, SingleBox.INACTIVE_SIT, SingleBox.LEFT_OBJECT, SingleBox.INACTIVE},
    	//Walk
	{SingleBox.WALKING, SingleBox.MOVING_SIT, SingleBox.WALKER, SingleBox.WALK},
	{SingleBox.WALKING, SingleBox.MOVING_SIT, SingleBox.WALKER, SingleBox.RUN},
    	//Enter
	{SingleBox.SHOPENTER_SCE, SingleBox.MOVING_SIT, SingleBox.WALKER, SingleBox.WALK},
    	{SingleBox.SHOPENTER_SCE, SingleBox.SHOPENTER_SIT, SingleBox.WALKER, SingleBox.WALK},
    	//Window shop
	{SingleBox.WINDOWSHOP_SCE, SingleBox.MOVING_SIT, SingleBox.WALKER, SingleBox.WALK},
	{SingleBox.WINDOWSHOP_SCE, SingleBox.SHOPENTER_SIT, SingleBox.WALKER, SingleBox.WALK},
    	{SingleBox.WINDOWSHOP_SCE, SingleBox.BROWSING_SIT, SingleBox.BROWSER, SingleBox.ACTIVE},
    	{SingleBox.WINDOWSHOP_SCE, SingleBox.BROWSING_SIT, SingleBox.BROWSER, SingleBox.INACTIVE},
	//Exit
    	{SingleBox.SHOPEXIT_SCE, SingleBox.MOVING_SIT, SingleBox.WALKER, SingleBox.WALK},
    	{SingleBox.SHOPEXIT_SCE, SingleBox.SHOPEXIT_SIT, SingleBox.WALKER, SingleBox.WALK},
    	//Reenter
    	{SingleBox.SHOPREENTER_SCE, SingleBox.MOVING_SIT, SingleBox.WALKER, SingleBox.WALK},
    	{SingleBox.SHOPREENTER_SCE, SingleBox.SHOPENTER_SIT, SingleBox.WALKER, SingleBox.WALK},
    	{SingleBox.SHOPREENTER_SCE, SingleBox.SHOPEXIT_SIT, SingleBox.WALKER, SingleBox.WALK},
	//Browse
    	{SingleBox.BROWSING, SingleBox.MOVING_SIT, SingleBox.WALKER, SingleBox.WALK},
	{SingleBox.BROWSING, SingleBox.BROWSING_SIT, SingleBox.BROWSER, SingleBox.ACTIVE},
	{SingleBox.BROWSING, SingleBox.BROWSING_SIT, SingleBox.BROWSER, SingleBox.INACTIVE},
	//drop down
    	{SingleBox.DROP_DOWN, SingleBox.MOVING_SIT, SingleBox.WALKER, SingleBox.WALK},
	{SingleBox.DROP_DOWN, SingleBox.BROWSING_SIT, SingleBox.BROWSER, SingleBox.ACTIVE},
	{SingleBox.DROP_DOWN, SingleBox.BROWSING_SIT, SingleBox.BROWSER, SingleBox.INACTIVE},
    	{SingleBox.DROP_DOWN, SingleBox.INACTIVE_SIT, SingleBox.WALKER, SingleBox.ACTIVE},
    	{SingleBox.DROP_DOWN, SingleBox.INACTIVE_SIT, SingleBox.WALKER, SingleBox.INACTIVE},
    //left object
    	{SingleBox.IMMOBILE,SingleBox.INACTIVE_SIT,SingleBox.LEFT_OBJECT,SingleBox.INACTIVE}
    };

    protected final static String[][] consistentGrpString = {
	{"none\t", "none\t", "none\t", "none\t"},
	{"meet\t", "move\t", "walker\t", "move\t"},
	{"meet\t", "join\t", "meet\t", "move\t"},
	{"meet\t", "interact", "meet\t", "active\t"},
	{"meet\t", "interact", "meet\t", "inactive"},
	{"meet\t", "split\t", "meet\t", "move\t"},
	{"walk\t", "move\t", "walker\t", "move\t"},
	{"shop enter", "move\t", "walker\t", "move\t"},
	{"shop enter", "shop enter", "walker\t", "move\t"},
	{"window shop", "move\t", "walker\t", "move\t"},
	{"window shop", "shop enter", "walker\t", "move\t"},
	{"window shop", "browsing", "walker\t", "active\t"},
	{"window shop", "browsing", "walker\t", "inactive"},
	{"shop exit", "move\t", "walker\t", "move\t"},
	{"shop exit", "shop exit", "walker\t", "move\t"},
	{"shop reenter", "move\t", "walker\t", "move\t"},
	{"shop reenter", "shop enter", "walker\t", "move\t"},
	{"shop reenter", "shop exit", "walker\t", "move\t"},
	{"left object", "move\t", "walker\t", "move\t"},
	{"left object", "leaving object", "walkers", "active\t"},
	{"left object", "leaving object", "walkers", "inactive\t"},
	{"fight\t", "move\t", "walker\t", "move\t"},
	{"fight\t", "join\t", "meet\t", "move\t"},
	{"fight\t", "join\t", "fighter\t", "move\t"},
	{"fight\t", "fight\t", "fighter\t", "active\t"},
	{"fight\t", "fight\t", "fighter\t", "inactive"},
	{"fight\t", "split\t", "fighter\t", "move\t"},
	{"fight\t", "left victim", "fighter\t", "active\t"},
	{"fight\t", "left victim", "fighter\t", "inactive"},
	{"fight\t", "inactive", "fighter\t", "inactive"},
	{"fight\t", "inactive", "fighter\t", "active\t"},
	{"fight\t", "inactive", "meeters\t", "inactive"},
	{"fight\t", "inactive", "meeters\t", "active\t"}
    };

    protected final static int[][] consistentGrp = {
	{GroupBox.NONE_SCE, GroupBox.NONE_SIT, GroupBox.NONE_ROLE, GroupBox.NONE_MOV},
	//Interact/meet
	{GroupBox.MEETING, GroupBox.GR_MOVING, GroupBox.WALKERS, GroupBox.MOVE},
	{GroupBox.MEETING, GroupBox.GR_MEETING, GroupBox.MEETERS, GroupBox.MOVE},
	{GroupBox.MEETING, GroupBox.GR_INTERACTING, GroupBox.MEETERS, GroupBox.ACTIVE},
	{GroupBox.MEETING, GroupBox.GR_INTERACTING, GroupBox.MEETERS, GroupBox.INACTIVE},
	{GroupBox.MEETING, GroupBox.GR_SPLITTING, GroupBox.MEETERS, GroupBox.MOVE},
	//Walk
	{GroupBox.GRWALKING_SCE, GroupBox.GR_MOVING, GroupBox.WALKERS, GroupBox.MOVE},
	//Enter
	{GroupBox.GRSHOPENTER_SCE, GroupBox.GR_MOVING, GroupBox.WALKERS, GroupBox.MOVE},
	{GroupBox.GRSHOPENTER_SCE, GroupBox.GRSHOPENTER_SIT, GroupBox.WALKERS, GroupBox.MOVE},
	//Windowshop
	{GroupBox.GRWINDOWSHOP_SCE, GroupBox.GR_MOVING, GroupBox.WALKERS, GroupBox.MOVE},
	{GroupBox.GRWINDOWSHOP_SCE, GroupBox.GRSHOPENTER_SIT, GroupBox.WALKERS, GroupBox.MOVE},
	{GroupBox.GRWINDOWSHOP_SCE, GroupBox.GRBROWSING_SIT, GroupBox.GRBROWSER_ROLE, GroupBox.ACTIVE},
	{GroupBox.GRWINDOWSHOP_SCE, GroupBox.GRBROWSING_SIT, GroupBox.GRBROWSER_ROLE, GroupBox.INACTIVE},
	//Exit
	{GroupBox.GRSHOPEXIT_SCE, GroupBox.GR_MOVING, GroupBox.WALKERS, GroupBox.MOVE},
	{GroupBox.GRSHOPEXIT_SCE, GroupBox.GRSHOPEXIT_SIT, GroupBox.WALKERS, GroupBox.MOVE},
	//Reenter
	{GroupBox.GRSHOPREENTER_SCE, GroupBox.GR_MOVING, GroupBox.WALKERS, GroupBox.MOVE},
	{GroupBox.GRSHOPREENTER_SCE, GroupBox.GRSHOPENTER_SIT, GroupBox.WALKERS, GroupBox.MOVE},
	{GroupBox.GRSHOPREENTER_SCE, GroupBox.GRSHOPEXIT_SIT, GroupBox.WALKERS, GroupBox.MOVE},
	//left
	{GroupBox.LEAVING, GroupBox.GR_MOVING, GroupBox.WALKERS, GroupBox.MOVE},
	{GroupBox.LEAVING, GroupBox.GR_LEFT_OBJECT, GroupBox.WALKERS, GroupBox.ACTIVE},
	{GroupBox.LEAVING, GroupBox.GR_LEFT_OBJECT, GroupBox.WALKERS, GroupBox.INACTIVE},
	//Fight
	{GroupBox.FIGHTING, GroupBox.GR_MOVING, GroupBox.WALKERS, GroupBox.MOVE},
	{GroupBox.FIGHTING, GroupBox.GR_MEETING, GroupBox.MEETERS, GroupBox.MOVE},
	{GroupBox.FIGHTING, GroupBox.GR_MEETING, GroupBox.FIGHTERS, GroupBox.MOVE},
	{GroupBox.FIGHTING, GroupBox.GR_FIGHTING, GroupBox.FIGHTERS, GroupBox.ACTIVE},
	{GroupBox.FIGHTING, GroupBox.GR_FIGHTING, GroupBox.FIGHTERS, GroupBox.INACTIVE},
	{GroupBox.FIGHTING, GroupBox.GR_SPLITTING, GroupBox.FIGHTERS, GroupBox.MOVE},
	{GroupBox.FIGHTING, GroupBox.GR_LEFT_VICTIM, GroupBox.FIGHTERS, GroupBox.ACTIVE},
	{GroupBox.FIGHTING, GroupBox.GR_LEFT_VICTIM, GroupBox.FIGHTERS, GroupBox.INACTIVE},
	{GroupBox.FIGHTING, GroupBox.GR_INACTIVE, GroupBox.FIGHTERS, GroupBox.INACTIVE},
	{GroupBox.FIGHTING, GroupBox.GR_INACTIVE, GroupBox.FIGHTERS, GroupBox.ACTIVE},
	{GroupBox.FIGHTING, GroupBox.GR_INACTIVE, GroupBox.MEETERS, GroupBox.INACTIVE},
	{GroupBox.FIGHTING, GroupBox.GR_INACTIVE, GroupBox.MEETERS, GroupBox.ACTIVE}
    };

    protected static int isConsistent(SingleBox box){
	int found = -1;
	boolean[] truths = box.getTruths();
	for(int i = 0; i<consistentInd.length; i++){
	    if(truths[consistentInd[i][0]] && truths[consistentInd[i][1]] &&
		    truths[consistentInd[i][2]] && truths[consistentInd[i][3]]){
		found = i;
	    }
	    else continue;
	    for(int j = 0; j<SingleBox.LENGTH; j++){
		if(j != consistentInd[i][0] && j != consistentInd[i][1] &&
			j != consistentInd[i][2] && j != consistentInd[i][3] &&
			j != SingleBox.APPEAR && j != SingleBox.DISAPPEAR &&
			j != SingleBox.OCCLUDED && j != SingleBox.PERSON_IMMOBILE &&
			truths[j]){
		    return -1;
		}
	    }
	}
	
	return found;
    }
    
    protected static int isConsistent(GroupBox box){
	int found = -1;
	boolean[] truths = box.getTruths();
	for(int i = 0; i<consistentGrp.length; i++){
	    if(truths[consistentGrp[i][0]] && truths[consistentGrp[i][1]] &&
		    truths[consistentGrp[i][2]] && truths[consistentGrp[i][3]]){
		found = i;
	    }
	    else continue;
	    for(int j = 0; j<GroupBox.LENGTH; j++){
		if(truths[j] && j != consistentGrp[i][0] && j != consistentGrp[i][1] &&
			j != consistentGrp[i][2] && j != consistentGrp[i][3] &&
			j != GroupBox.APPEAR && j != GroupBox.DISAPPEAR &&
			j != GroupBox.FIGHT_START && j != GroupBox.FIGHT_END &&
			j != GroupBox.FIGHT_VICTIM_LEFT){
		    return -1;
		}
	    }
	}
	
	return found;
    }
}
